/*
 * Created on 4-feb-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jodie.core;

import jodie.kb.Term;
import jodie.kb.TermList;

/**
 * @author da
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Utils {

    private static final Runtime s_runtime = Runtime.getRuntime ();
	
	public Utils() {
	}
	
	/* niftyName cleans string names such as
	 *   http://www.owl-ontologies.com/unnamed.owl#WhatEver
	 * stripping away the namespace
	 */
	public static String niftyName(String s){
		if (Config.niftyNames && s!=null){
			// strip away namespace from names
			int i = s.indexOf("#");
			if (i>0) s = s.substring(i+1);
		}
		return s;
	}

	/* this is mostly used for debugging purposes
	 * returns a term given a term in string format
	 * like: not(some(hasTopping,whatever)); atleast(hasTopping,TOP,3);
	 */
	public static TermList stringToTerm (String from){
		TermList l = new TermList();
		
		// take away all the spaces
		from = from.replaceAll("\\s","");
		int i = 0;
		String to = "";
		while (i<from.length()){
			char c = from.charAt(i);
			if (c == '('){
				// create an OPER term with name = to
				//System.out.println("*** OPER="+to);
				Term t = new Term(Term.OPER,to); 
				to = "";
				
				// find the closing parenthesis and create content string
				int close = findClose(from,i);
				String content = from.substring(i+1,close);
				i = close;
				
				// convert content to terms and add them to t as children
				TermList children = stringToTerm(content);
				if (t.getName().equals(Term.ATL) || t.getName().equals(Term.ATM)){
					// get the last child (it's the VALUE we want to assign to the term!)
					// NOTE: setting value as THE LAST child means that we can either write
					//       atleast(role,TOP,val)  or 
					//       atleast(role,val)      following OWL non-qualified roles
					Term value = (Term)children.removeLast();
					t.setVal(Integer.parseInt(value.getName()));
					t.addChildren(children);
					t.addChild(Term.TOP);
				}else{
					t.addChildren(children);
				}
				
				// add term to the LinkedList
				l.add(t);
				//System.out.println (t);

			}else if (c == ','){
				if (to != ""){
					//System.out.println("*** TERM="+to);
					Term t = new Term(Term.TERM,to); 
					l.add(t);
					to = "";
				}
			}else{
				to += c;
			}
			i++;
		}

		if (to != ""){
			//System.out.println("*** TERM="+to);
			Term t = new Term(Term.TERM,to); 
			l.add(t);
			to = "";
		}
		return l;
	}

    public static long usedMemory ()
    {
        return s_runtime.totalMemory () - s_runtime.freeMemory ();
    }

	private static int findClose(String s, int offs){
		int i = offs+1;
		int depth = 1;
		
		while (i<s.length()){
			char d = s.charAt(i);
			if (d == '(') depth++;
			if (d == ')') depth--;
			if (depth == 0) return i;
			i++;
		}
		return 0;
	}

}
