/*
 * Created on 13-dic-2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jodie.dig;

import java.util.HashMap;
import java.util.LinkedList;

import jodie.core.Config;
import jodie.kb.KnowledgeBase;
import jodie.kb.Term;

import org.xml.sax.Attributes;


/**
 * @author da
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Element {
	private boolean DEBUG = Config.DEBUG && true;
	private String name;
	private HashMap attrs;
	private LinkedList children; 
	
	public Element(String name, Attributes a) {
		this.name = name;
		this.children = new LinkedList();
		this.attrs = new HashMap(8);

		// fill attributes hashmap
		for (int i=0;i<a.getLength();i++){
			attrs.put(a.getQName(i),a.getValue(i));
		}
		
	}

	public void addChild (Element child){
		children.addLast(child);
	}
	
	public Element getChild(String name){
		return getChild (name,1);
	}

	/*
	 * Get the n-th child with the same name
	 */
	public Element getChild(String name, int n){
		if (n==0) return null;
		for (int i=0;i<children.size();i++){
			Element e = (Element)children.get(i);
			if (e.getName().equalsIgnoreCase(name)){
				n--;
				if (n==0) return e;
			}
		}
		return null;
	}

	/*
	 * Just get the n-th child 
	 */
	public Element getChild(int n){
		if (n==0) return null;
		for (int i=0;i<children.size();i++){
			Element e = (Element)children.get(i);
			n--;
			if (n==0) return e;
		}
		return null;
	}
	
	public String getName(){
		return this.name;
	} 
	
	public String getAttr(){
		String string = "";
		Object[] keys = attrs.keySet().toArray();
		for (int i=0;i<keys.length;i++){
			string = string + keys[i] + ": " + attrs.get(keys[i]) + "\n";
		}
		return string;
	}
	
	public String getAttr(String name){
		return (String)attrs.get(name);
	}
	
	public String toString(){
		return toString(1);
	}
	
	public String toString(int space){
		String string = "";
		// foreach child
		for (int i=0;i<children.size();i++){
			Element e = (Element)children.get(i);
			// add spaces
			for (int j=0;j<=space;j++){
				string = string + " ";
			}
			// return child
			string = string + e.getName() + "\n" ;
			string = string + e.getAttr();

			// return children 
			string = string + e.toString(space+1);
		}
		return string;
	}
	
	public Term toTerm(KnowledgeBase kb){
		Term t;

		// if name is ratom or catom then create a simple term
		if (this.name.equalsIgnoreCase("catom")||
			this.name.equalsIgnoreCase("ratom")){
			t = new Term(Term.TERM,this.getAttr("name"));
		}
		// TOP
		else if (this.name.equalsIgnoreCase("top")){
			t = Term.TOP;
		}
		
		// else switch
		else if (this.name.equalsIgnoreCase("and") ||
				 this.name.equalsIgnoreCase("or")  ||
				 this.name.equalsIgnoreCase("not") ||
				 this.name.equalsIgnoreCase("some")||
				 this.name.equalsIgnoreCase("all")){
			// create a complex term
			t = new Term (Term.OPER,this.name);
			// foreach child
			for (int i=0;i<children.size();i++){
				Element e = (Element)children.get(i);
				// convert to term and add
				t.addChild(e.toTerm(kb));
			}
		}
		// else switch (extract num from restrictions)
		else if (this.name.equalsIgnoreCase("atleast")||
				 this.name.equalsIgnoreCase("atmost")){
			// create a complex term
			t = new Term (Term.OPER,this.name);
			// add a restriction value child
			t.setVal(Integer.parseInt(this.getAttr("num")));
			// foreach child
			for (int i=0;i<children.size();i++){
				Element e = (Element)children.get(i);
				// convert to term and add
				t.addChild(e.toTerm(kb));
			}
			// set "N" expressivity flag (non-qualified restrictions) 
			kb.getEx().isN(true);
		}
		else {
			System.out.println ("***ERROR IN TERM CREATION: unknown "+this.name);
			t = new Term(Term.TERM,"null");
		}
		return t;
	}
}
