/*
 * Created on Feb 24, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jodie.dig;

import java.math.BigInteger;

import org.kr.dl.dig.v1_1.ErrorDocument;
import org.kr.dl.dig.v1_1.IdRespType;
import org.kr.dl.dig.v1_1.IdentifierDocument;
import org.kr.dl.dig.v1_1.ResponseDocument;
import org.kr.dl.dig.v1_1.SupportsType;
import org.kr.dl.dig.v1_1.IdentifierDocument.Identifier;
import org.kr.dl.dig.v1_1.KbDocument.Kb;
import org.kr.dl.dig.v1_1.SupportsType.Ask;
import org.kr.dl.dig.v1_1.SupportsType.Language;
import org.kr.dl.dig.v1_1.SupportsType.Tell;

/**
 * @author eynard
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

public class Res {

	// response fixed part
	private static final String header	  = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";

	// ERRORS :: General
	public static final String	ERR_GENERAL_UNSPECIFIED_ERROR	= "100";
	public static final String	ERR_UNKNOWN_REQUEST				= "101";
	public static final String	ERR_MALFORMED_REQUEST			= "102";
	public static final String	ERR_USUPPORTED_OPERATION		= "103";

	// ERRORS :: KB
	public static final String	ERR_CANNOT_CREATE_NEW_KB		= "201";
	public static final String	ERR_MALFORMED_KB_URI			= "202";
	public static final String	ERR_UNKNOWN_OR_STALE_KB_URI		= "203";
	public static final String	ERR_KB_RELEASE_ERROR			= "204";
	public static final String	ERR_MISSING_URI					= "205";

	// ERRORS :: Tell
	public static final String	ERR_GENERAL_TELL_ERROR			= "300";
	public static final String	ERR_UNSUPPORTED_TELL_OPERATION	= "301";
	public static final String	ERR_UNKNOWN_TELL_OPERATION		= "302";

	// ERRORS :: Ask
	public static final String	ERR_GENERAL_ASK_ERROR			= "400";
	public static final String	ERR_UNSUPPORTED_ASK_OPERATION	= "401";
	public static final String	ERR_UNKNOWN_ASK_OPERATION		= "402";


	
	private String body = "";
	
	public Res(){
		//opts.setCharacterEncoding("UTF-8");
	}

	public void makeOk(){
		ResponseDocument doc = ResponseDocument.Factory.newInstance();
		doc.addNewResponse().addNewOk();
		body = doc.toString();
	}

	
	public void makeErr(String code){
		if (code == null) code = ERR_GENERAL_UNSPECIFIED_ERROR;
		
		// NOTE: this is _SLOW_!!!
		ResponseDocument doc = ResponseDocument.Factory.newInstance();
		IdRespType resp = doc.addNewResponse();
		ErrorDocument.Error err = resp.addNewError();
		err.setCode(new BigInteger(code));
		body = doc.toString();
	}

	public void makeErr(){
		makeErr(ERR_GENERAL_UNSPECIFIED_ERROR);
	}
	
	public void makeNewKB(){
		ResponseDocument doc = ResponseDocument.Factory.newInstance();
		IdRespType resp = doc.addNewResponse();
		Kb kb = resp.addNewKb();
		kb.setUri("urn:uuid:abcdefgh-1234-1234-12345689ab");
		body = doc.toString();
	}
	
	public void makeIdent(){
		IdentifierDocument doc = IdentifierDocument.Factory.newInstance();
		Identifier id = doc.addNewIdentifier();
		id.setName("Jodie");
		id.setVersion("1.0");
		id.setMessage("Jodie running on my pc");
		
		// create main sections
		SupportsType supp	= id.addNewSupports();
		Ask 		ask		= supp.addNewAsk();
		Tell 		tell	= supp.addNewTell();
		Language	lang 	= supp.addNewLanguage();

		// fill ask
		// see http://dig.sourceforge.net/javadoc-xmlbeans/1.1/org/kr/dl/dig/v1_1/SupportsType.Ask.html
		ask.addNewSatisfiable();
		
		// fill tell
		// see http://dig.sourceforge.net/javadoc-xmlbeans/1.1/org/kr/dl/dig/v1_1/SupportsType.Tell.html
		tell.addNewDefconcept();
		tell.addNewDefrole();
		tell.addNewDefindividual();
		tell.addNewDefattribute();
		tell.addNewDeffeature();
		tell.addNewDomain();
		tell.addNewRange();
		tell.addNewEqualc();
		tell.addNewEqualr();
		tell.addNewFunctional();
		tell.addNewImpliesc();
		tell.addNewImpliesr();
		tell.addNewTransitive();
		tell.addNewInstanceof();
		
		tell.addNewValue();
		tell.addNewRangeint();
		tell.addNewRangestring();
		tell.addNewDisjoint();
		tell.addNewRelated();
				
		// fill lang
		// see http://dig.sourceforge.net/javadoc-xmlbeans/1.1/org/kr/dl/dig/v1_1/SupportsType.Language.html
		lang.addNewTop();
		lang.addNewBottom();
		lang.addNewCatom();
		lang.addNewRatom();
		lang.addNewIndividual();
		lang.addNewAttribute();
		lang.addNewFeature();
		lang.addNewInverse();
		lang.addNewAnd();
		lang.addNewOr();
		lang.addNewNot();
		lang.addNewSome();
		lang.addNewAll();
		lang.addNewAtmost();
		lang.addNewAtleast();
		
		body = doc.toString();
	}
	
	public String getResponse(){
		return header+this.body;
	}


}
