/*
 * Created on 24-nov-2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jodie.gui;

import java.io.FileInputStream;

import jodie.core.Config;
import jodie.core.Log;
import jodie.core.LogFilterInputStream;
import jodie.service.XML;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;



/**
 * @author da
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class MainMenu {
	
	private Shell shell;
	private MainWindow window;
	private MainTabs mainTabs;
	
	// these menuitems are declared here 'cause they have to be
	// enabled/disabled by listener functions
	private MenuItem dig_run;
	private MenuItem dig_stop;
	private MenuItem kb_open;
	private MenuItem kb_close;
	
	// this is the kbQuery tab, used to manually send queries 
	// to the KB. It can be enabled or disabled
	private QueryTab kbQuery;
	
    public MainMenu(MainWindow mainWindow) {
    	window 		= mainWindow;
 	    shell 		= window.getShell();
    }
	
	public void buildMenu() {
    	mainTabs 	= window.getMainTabs();

	    Menu menu = new Menu(shell, SWT.BAR);
	    shell.setMenuBar(menu);
	    
	    // menu - file
	    MenuItem file = new MenuItem(menu, SWT.CASCADE);
	    file.setText("File");
	    Menu filemenu = new Menu(shell, SWT.DROP_DOWN);
	    file.setMenu(filemenu);

	    // menu - file - open
	    MenuItem file_open = new MenuItem(filemenu, SWT.PUSH);
	    file_open.setText("Open DIG/Tells");

	    // menu - file - exit
	    MenuItem file_exit = new MenuItem(filemenu, SWT.PUSH);
	    file_exit.setText("Exit");

	    // menu - dig
	    MenuItem dig = new MenuItem(menu, SWT.CASCADE);
	    dig.setText("Dig");
	    Menu digmenu = new Menu(shell, SWT.DROP_DOWN);
	    dig.setMenu(digmenu);

	    // menu - dig - run
	    dig_run = new MenuItem(digmenu, SWT.PUSH);
	    dig_run.setText("Run");
	    
	    dig_stop = new MenuItem(digmenu, SWT.PUSH);
	    dig_stop.setText("Stop");
	    dig_stop.setEnabled(false);

	    // menu - kb
	    MenuItem kb = new MenuItem(menu, SWT.CASCADE);
	    kb.setText("KB");
	    Menu kbmenu = new Menu(shell, SWT.DROP_DOWN);
	    kb.setMenu(kbmenu);

	    // menu - KB - open
	    kb_open = new MenuItem(kbmenu, SWT.PUSH);
	    kb_open.setText("Open query tab");

	    // menu - KB - close
	    kb_close = new MenuItem(kbmenu, SWT.PUSH);
	    kb_close.setText("Close query tab");

	    kb_close.setEnabled(false);
	    
	    // menu - help
	    MenuItem help = new MenuItem(menu, SWT.CASCADE);
	    help.setText("Help");
	    Menu helpmenu = new Menu(shell, SWT.DROP_DOWN);
	    help.setMenu(helpmenu);
	    
	    // menu - help - about
	    MenuItem help_about = new MenuItem(helpmenu, SWT.PUSH);
	    help_about.setText("About");

    //---------------- LISTENERS ---------------------------
    
	    file_exit.addListener(SWT.Selection, new Listener(){

	    	public void handleEvent(Event e){
	    		shell.dispose();
	    	}
	    });

	    file_open.addListener(SWT.Selection, new Listener(){

	    	public void handleEvent(Event e){
	    		String[] filterExtensions = {"*.*","*.dig","*.xml"};
	    		FileDialog fd = new FileDialog (shell,SWT.OPEN);
	    		fd.setText("Open DIG/Tells");
	    		fd.setFilterPath("~/");
	    		fd.setFilterExtensions(filterExtensions);
	    		String digFile = fd.open();
	    		
	    		Log log = new Log("DIG/Tells",Log.GUI);
	    		log.out(digFile);
	    		
	    		try{
	    			FileInputStream in = new FileInputStream(digFile); 
		    		LogFilterInputStream is = new LogFilterInputStream(in,log);
		    		XML xml = new XML();
		    		xml.parse(is);
	    		}catch (Exception e2){
	    			System.out.println(e2);
	    		}
	    	}
	    });
	    
	    dig_run.addListener(SWT.Selection, new Listener(){
	    	public void handleEvent(Event e){
	    		Config.core.log.out("Running HTTP server...");
				try {
					window.getJodieCore().http_start();

					Config.core.log.out("HTTP server up and running at port " + Config.httpPort);
			        dig_run.setEnabled(false);
			        dig_stop.setEnabled(true);
				} catch (Exception e1){
					e1.printStackTrace();
					Config.core.log.out("Could not start HTTP server.");
				}
	    	}
	    });

	    dig_stop.addListener(SWT.Selection, new Listener(){
	    	public void handleEvent(Event e){
	    		Config.core.log.out("Stopping HTTP server...");
				try {
					Config.core.http_stop();

					Config.core.log.out("HTTP server stopped.");
			        dig_run.setEnabled(true);
			        dig_stop.setEnabled(false);
				} catch (Exception e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
	    	}
	    });

	    kb_open.addListener(SWT.Selection, new Listener(){
	    	public void handleEvent(Event e){
	    		kbQuery = new QueryTab("KB Query");
	    		kb_open.setEnabled(false);
	    	    kb_close.setEnabled(true);
	    	}
	    });		

	    kb_close.addListener(SWT.Selection, new Listener(){
	    	public void handleEvent(Event e){
	    		kbQuery.dispose();
		        kb_open.setEnabled(true);
		        kb_close.setEnabled(false);
	    	}
	    });		

    }
}
