/*
 * Created on 17-gen-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jodie.kb;

import java.util.LinkedList;

import jodie.core.Config;
import jodie.core.Utils;


/**
 * @author da
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Concept {

	private String name;

	private TermList implies = new TermList();
	private TermList equals = new TermList();

	private final static String unfolded_prefix = "";
	
	public Concept(String name) {
		this.name = name;
	}

	public void addImplies(Term t){
		if (!t.getName().equalsIgnoreCase("owl:Thing"))
			implies.add(t);
	}

	public void addEquals(Term t){
		equals.add(t);
	}

	public void addDisjoint(Term t){
		implies.add(t.negate());
	}

	public Term lazyExpand(TBox tbox, LinkedList seen){
		Term t, eqt;

		Config.core.log.out("Expanding concept " + this.name);

		// get the equals
		int eqsize = equals.size(); 
		if (eqsize == 0){
			eqt = null;
		}else if (eqsize == 1){
			eqt = (Term)equals.getFirst(); 
		}else{
			Config.core.log.out("Concept " + this.name + "is not unfoldable (multiple definitions)");
			eqt = null;
		}
		

		// get the implies
		int impsize = implies.size();
		if (impsize == 0){
			if (eqt != null){
				// no implies -> t is equal to its "equalc", unfolded
				t = eqt.lazyUnfold(tbox,seen);
			}else{
				t = null;
			}
		}else{
			// concept has at least one implies => join them together with an AND
			t = new Term (Term.OPER,Term.AND);
			// if concept has an equals, add it
			if (eqt != null) t.addChild(eqt);

			// add this name, modified so it won't be unfolded again
			Term mainChild = Utils.stringToTerm(this.name).getTerm(0);
			mainChild.setUnfolded();
			t.addChild(mainChild);
			
			// add all implied terms
			for (int i=0;i<implies.size();i++){
				Term child = implies.getTerm(i);
				child.normalize();
				//in their unfolded form, avoiding loops (using seen!), 
				// if the term is not a disjoint 
				if (!child.getName().equalsIgnoreCase(Term.NOT)){
					t.addChild(child.lazyUnfold(tbox,seen));
				}else{
					tbox.notDepth++;
					if (tbox.notDepth>0){
						//System.out.println ("NOT depth is "+tbox.notDepth+": won't unfold child");
						child.setUnfolded();
						t.addChild(child);
					}else{
						//System.out.println ("NOT depth is "+tbox.notDepth+": will unfold child");
						t.addChild(child.lazyUnfold(tbox,seen));
					}
					tbox.notDepth--;
				}
			}			
		}
		return t;
	}
	
	public String toString(){
		int j;
		String string = "\n"; // just for impagination

		string += "Concept Name: " + Utils.niftyName(this.name);
		string += "\n        Impl: " + implies;
		string += "\n        Equa: " + equals;
		return string;
	} 
}
