/*
 * Created on 10-gen-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jodie.kb;

import java.io.FileWriter;
import java.io.IOException;

import jodie.core.Config;
import jodie.core.Core;
import jodie.core.Utils;
import jodie.strategies.Strategy;
import jodie.tableaux.Assertion;
import jodie.tableaux.Tableaux;

/**
 * @author da
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class KnowledgeBase {

	private Core core;
	private ABox A;
	private TBox T;
	private Expressivity ex; 
	
	public KnowledgeBase(Core core) {
		this.core = core;
		this.A = new ABox(this);
		this.T = new TBox(this);
		this.ex = new Expressivity();
	}
	
	public String toString(){
		return T.toString() + A.toString();
	} 

	public TBox getTBox(){
		return T;
	}

	public ABox getABox(){
		return A;
	}
	
	public Expressivity getEx(){
		return ex;
	}

	public void addDefConcept(String name){
		T.addDefConcept(name);
	}

	public void addDefRole(String name){
		T.addDefRole(name);
	}

	public void addDefFeature(String name){
		// FIX HERE
		T.addDefRole(name,Role.DATATYPE);
	}

	public void addDefAttribute(String name){
		T.addDefRole(name,Role.DATATYPE);
	}

	public void addDefIndividual(String name){
		A.addDefIndividual(name);
	}

	public void addDefRole(String name, int datatype){
		T.addDefRole(name,datatype);
	}
	
	public void addImpliesC(String concept1, Term concept2){
		T.addImpliesC(concept1,concept2);
	}

	public void addEqualC(String concept1, Term concept2){
		T.addEqualC(concept1,concept2);
	}

	public void addDisjoint(String concept1, Term concept2){
		T.addDisjoint(concept1,concept2);
	}
	
	public void addImpliesR(String role1, String role2){
		T.addImpliesR(role1,role2);
		// add "H" flag to expressivity
		ex.isH(true);
	}
	
	public void addInverseR(String role1, String role2){
		T.addInverseR(role1,role2);
		// add "I" flag to expressivity
		ex.isI(true);
	}

	public void setRoleDomain(String role, String domain){
		T.setRoleDomain(role,domain);
	}

	public void setRoleRange(String role, String range){
		T.setRoleRange(role,range);
	}

	public void setRangeInt(String name){
		T.setRangeInt(name);
	}

	public void setRangeString(String name){
		T.setRangeString(name);
	}

	public void setTransitive(String name){
		T.setTransitive(name);
		ex.isS(true);
	}

	public void setFunctional(String name){
		T.setFunctional(name);
		ex.isF(true);
	}

	public void addInstanceOf(String i, String c){
		A.addInstanceOf(i,c);
	}
	
	public void addRelated(String i1 ,String r, String i2){
		A.addRelated(i1,r,i2);
	}
	
	public Strategy getStrategy(Tableaux tab){
		Strategy strategy = null;
		String sname = null;
		
		// get strategy from config
		Config.core.log.out("[Strategy] Getting strategies for expressivity " + this.ex);
		sname = (String)Config.strategies.get(this.ex.toString());

		// if there's no matching strategy for this expressivity fall back
		// to ALL setting
		if (sname==null) {
			Config.core.log.out("[Strategy] No matching strategy. Falling back to ALL setting");
			sname = (String)Config.strategies.get("ALL");
		}
		Config.core.log.out("[Strategy] Matching strategy is " + sname);
		
		try{
			Class strategyClass = Class.forName("jodie.strategies.Strategy" + sname);
			strategy = (Strategy)strategyClass.newInstance();
			strategy.setTableaux(tab);
		}catch(Exception e){
			e.printStackTrace();
			System.exit(0);
		}
		return strategy;
	}
	
	public boolean isSatisfiable(String s){
		Term	t = Utils.stringToTerm(s).getTerm(0);
		
		Config.core.timers.startTimer("Rulez");
		Tableaux tab = new Tableaux(this);
		tab.getRootNode().addAssertion(new Assertion(t));
		
		// print the tableaux with just its root node 
		// System.out.println (tab);
		
		// apply tableaux rules
		tab.applyRules();
		Config.core.timers.stopTimer("Rulez");

		Config.core.timers.startTimer("Dump");
		// print the final tableaux 
		//String th = "["+tab.hashCode()+"] ";
		//System.out.println (th+tab);

		try {
			FileWriter fw = new FileWriter(Config.tableauxXml);
			fw.write(tab.toXML());
			fw.close();
		} catch (IOException e1) {
			e1.printStackTrace();
		}

		// save tableaux as a PNG
		tab.toPNG();
		Config.core.timers.stopTimer("Dump");
		
		return !tab.clashes();
	}

}
