/*
 * Created on 17-gen-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jodie.kb;

import java.util.LinkedList;

import jodie.core.Utils;


/**
 * @author da
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Role {

	final public static String[] TYPES = {"Undefined", "Object", "Datatype", "Annotation", "Ontology"	};
	final public static int UNDEFINED  = 0;
	final public static int OBJECT     = 1; // ?
	final public static int DATATYPE   = 2;
	final public static int ANNOTATION = 3; // ?
	final public static int ONTOLOGY   = 4; // ?

	private String name;
	private int  type = UNDEFINED; 
	private Role inverse = null;

	private LinkedList subRoles = new LinkedList();
	private LinkedList superRoles = new LinkedList();

	// NOTE: at the moment, domain and range only hold ONE concept.  
	private String domain = null;
	private String range  = null;

	private boolean isTransitive = false;
	private boolean isFunctional = false;
	private boolean rangeString  = false;
	private boolean rangeInt     = false;
	
	public Role(String name) {
		this(name, UNDEFINED);
	}

	public Role(String name, int type) {
		this.name = name;
		this.type = type;
		
		addSubRole(this.name);
		addSuperRole(this.name);
	}
	
	public void addSubRole(String r) {
		subRoles.add(r);
	}
	
	public void addSuperRole(String r) {		
		superRoles.add(r);
	}

	public boolean isDatatypeRole() {
		return type == DATATYPE; 
	}

	public String getName(){
		return name;
	}
	
	public Role getInverse() {
		return inverse;
	}
	
	public LinkedList getSuperRoles(){
		return this.superRoles;
	}

	public boolean hasInverse() {
		return inverse != null;
	}

	public boolean isFunctional(){
		return this.isFunctional;
	}

	public boolean isTransitive(){
		return this.isTransitive;
	}

	public boolean implies(Role r){
		return superRoles.contains(r.getName());
	}

	public boolean subsumes(Role r){
		return subRoles.contains(r.getName());
	}

	public void setDomain (String s){
		domain = s;
	}

	public void setRange (String s){
		range = s;
	}

	public void setRangeString(boolean b) {
		rangeString = b;
	}

	public void setRangeInt(boolean b) {
		rangeInt = b;
	}

	public void setInverse(Role r) {
		inverse = r;
	}

	public void setFunctional(boolean b) {
		isFunctional = b;
	}

	public void setTransitive(boolean b) {
		isTransitive = b;
	}

	public void setType(int type) {
		this.type = type;
	}
	
	public String toString (){
		int j;
		
		String string = "\n"; // \n is added to niftly write "values"
		string += "Role Name: " + Utils.niftyName(this.name) + "\n";
		string += "     Type: " + TYPES[type] + "\n";
		string += "     Domn: " + Utils.niftyName(domain) + "\n";
		string += "     Rang: " + Utils.niftyName(range) + "\n";
		if (hasInverse()) string += "     Inve: " + Utils.niftyName(getInverse().name) + "\n";
		
		// implies
		string += "     Impl: ";
		j =superRoles.size(); 
		string += "[";
		for (int i=0;i<j;i++){
			string += Utils.niftyName(superRoles.get(i).toString());
			if (i<j-1) string += ", ";
		}
		string += "]\n";
		
		// subsumes
		string += "     Subs: ";
		j =subRoles.size(); 
		string += "[";
		for (int i=0;i<j;i++){
			string += Utils.niftyName(subRoles.get(i).toString());
			if (i<j-1) string += ", ";
		}
		string += "]\n";

		// properties
		string = string + "     Prop: ";
		if (isFunctional) string += "F";
		if (isTransitive) string += "T";
		if (rangeString)  string += "s";
		if (rangeInt)     string += "i";
		return string;
	}
	
}
