/*
 * Created on 10-gen-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jodie.kb;

import java.util.HashMap;

import jodie.core.Config;

/**
 * @author da
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class TBox {

	private HashMap roles		= new HashMap();
	private HashMap concepts	= new HashMap();
	private KnowledgeBase kb;

	private HashMap expansions	= new HashMap();
	
	public int notDepth = 0;

	public TBox(KnowledgeBase kb) {
		this.kb = kb;
	}

	public void addDefConcept(String name){
		Concept concept = new Concept (name);
		concepts.put(name,concept);
	}

	public void addDefRole(String name){
		addDefRole (name,Role.UNDEFINED);
	}

	public void addDefRole(String name, int type){
		Role role = getRole(name);
		
		if(role == null) {
			role = new Role(name, type);
			roles.put(name, role);				
		}
	}

	public void addImpliesC(String name, Term t){
		Concept c = getConcept(name);
		if (c!=null){
			c.addImplies(t);
		}else{
			Config.core.log.out("Trying to use addImpliesC on a non existing concept (" + name + ")");
		}
	}

	public void addEqualC(String name, Term t){
		Concept c = getConcept(name);
		if (c!=null){
			c.addEquals(t);
		}else{
			Config.core.log.out("Trying to use addEqualC on a non existing concept (" + name + ")");
		}
	}
	
	public void addDisjoint(String name, Term t){
		Concept c = getConcept(name);
		if (c!=null){
			c.addDisjoint(t);
		}else{
			Config.core.log.out("Trying to use addDisjoint on a non existing concept (" + name + ")");
		}
	}

	public void addImpliesR(String role1, String role2){
		Role r1 = getRole(role1);
		Role r2 = getRole(role2);
		if ((r1!=null)&&(r2!=null)){
			r1.addSuperRole(r2.getName());
			r2.addSubRole(r1.getName());
		}else{
			Config.core.log.out("Trying to use addImpliesR without a role (null roles: ");
			if (r1==null) Config.core.log.out(role1 + ", ");
			if (r2==null) Config.core.log.out(role2);
			Config.core.log.out(")");
		}
	}

	public void addInverseR(String role1,String role2){
		Role r1 = getRole(role1);
		Role r2 = getRole(role2);
		if ((r1!=null)&&(r2!=null)){
			if (!r1.hasInverse() && !r2.hasInverse()){
				r1.setInverse(r2);
				r2.setInverse(r1);
			}else{
				Config.core.log.out("Role ("+ role1 +", "+ role2 +") already has an inverse");
			}
		}else{
			Config.core.log.out("Trying to use addInverseR without a role (null roles: ");
			if (r1==null) Config.core.log.out(role1 + ", ");
			if (r2==null) Config.core.log.out(role2);
			Config.core.log.out(")");
		}
	}
	
	public void setRoleDomain(String role, String domain){
		Role r = getRole(role);
		if (r!=null){
			r.setDomain(domain);
		}else{
			Config.core.log.out("setRoleDomain could not find role " + role);
		}
	}

	public void setRoleRange(String role, String range){
		Role r = getRole(role);
		if (r!=null){
			r.setRange(range);
		}else{
			Config.core.log.out("setRoleRange could not find role " + role);
		}
	}

	public void setRangeInt(String name){
		Role r = getRole(name);
		if (r!=null){
			r.setRangeInt(true);
		}else{
			Config.core.log.out("setRangeInt could not find role " + name);
		}
	}

	public void setRangeString(String name){
		Role r = getRole(name);
		if (r!=null){
			r.setRangeString(true);
		}else{
			Config.core.log.out("setRangeString could not find role " + name);
		}
	}

	public void setTransitive(String name){
		Role r = getRole(name);
		if (r!=null){
			r.setTransitive(true);
		}else{
			Config.core.log.out("setTransitive could not find role " + name);
		}
	}

	public void setFunctional(String name){
		Role r = getRole(name);
		if (r!=null){
			r.setFunctional(true);
		}else{
			Config.core.log.out("setFunctional could not find role " + name);
		}
	}

	
	public Role getRole(String name) {
		return (Role)roles.get(name);
	}

	public Concept getConcept(String name) {
		return (Concept)concepts.get(name);
	}

	public HashMap getExpansions() {
		return this.expansions;
	}
	
	public String toString(){
		String string = "";
		
		// concepts
		string += "Concepts:\n" + concepts.values() + "\n";
		
		// roles
		string += "Roles:\n" + roles.values() + "\n";

		return string;
	}
}
