/*
 * Created on Mar 22, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jodie.strategies;

import java.util.ListIterator;

import jodie.core.Config;
import jodie.kb.Term;
import jodie.tableaux.Assertion;
import jodie.tableaux.Node;
import jodie.tableaux.NodeList;

/**
 * @author eynard
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class StrategyALCf extends StrategyALC{

	// inherited protected attributes:
	// Tableaux tab;
	// boolean DEBUG
	
	public StrategyALCf() {
		super();
	}

	public void applySomeRule(Node n){
		// NOTE: this method should not create immediate clashing nodes:
		// - first of all, it's always a new node (so no conflicts with ex. ones)
		// - then, the new term is pushed in the queue so if it clashes we'll 
		//   see that later

		Config.core.timers.startTimer("[TAB][SOME]");

		if (DEBUG) tab.log.out ("[SOME] Applying SOME rule on node " + n.getName());

		ListIterator li = n.getAsserts().listIterator();
		while (li.hasNext()){
			// for each assertion
			Assertion ass = (Assertion)li.next();
			Term t = ass.getTerm();
			// if the assertion has the form some(role,concept)
			if (t.isComplex() && t.getName().equalsIgnoreCase(Term.SOME)){

				if (DEBUG) tab.log.out ("[SOME] found " + t);
				// remove it
				li.remove();
				// first term should be a simple role
				Term role = t.getChild(0);
				// second term should be a generic concept
				Term concept = t.getChild(1);

				// NOTE: first check if a node connected through Role...
				NodeList nl = n.getChildren(role.getName());

				// if no role is found ...
				if (nl.isEmpty()){
					String nodeName = n.getTableaux().getNewAnon();
					if (DEBUG) tab.log.out ("[SOME] creating new node for " + t + "(name: "+ nodeName +")");
					// create a new node with an anonymous name
					Node child = new Node(nodeName,n.getTableaux());
					// make it the child of the current node,
					// through an edge with role's name
					n.addChild(child,role.getName());
					// add the concept to the new node as an assertion
					child.addAssertion(ass.spawn(concept));
					// add the new node to the queue
					n.getTableaux().enqueueNode(child);
				}else{
					// check if a node asserting Concept exists yet
					boolean found = false;
					for (int i=0;i<nl.size();i++){
						Node child = (Node)nl.get(i);
						if (child.contains(concept)){
							found = true;
							break;
						}
					}
					
					// if a node asserting Concept exists yet do nothing
					// else
					if (!found){
						// a node connected by role exists, but it doesn't assert Concept
						if (tab.getKB().getTBox().getRole(role.getName()).isFunctional()){
							// if role is functional, add the concept to this node asserts
							Node child = (Node)nl.get(0); // only one child for functionals
							if (DEBUG) tab.log.out ("[SOME] role "+ role.getName() 
									+" is functional: adding assert " + concept
									+" to node " + child.getName());
							child.addAssertion(ass.spawn(concept));
							// add the new node to the queue
							n.getTableaux().enqueueNode(child);
						}else{
							// else create a new node, as above
							String nodeName = n.getTableaux().getNewAnon();
							if (DEBUG) tab.log.out ("[SOME] creating new node for " + t + "(name: "+ nodeName +")");
							// create a new node with an anonymous name
							Node child = new Node(nodeName,n.getTableaux());
							// make it the child of the current node,
							// through an edge with role's name
							n.addChild(child,role.getName());
							// add the concept to the new node as an assertion
							child.addAssertion(ass.spawn(concept));
							// add the new node to the queue
							n.getTableaux().enqueueNode(child);
						}
					}
				}

				
			}
		}
		Config.core.timers.stopTimer("[TAB][SOME]");
	}
}
