/*
 * Created on Mar 22, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jodie.strategies;

import java.util.ListIterator;

import jodie.core.Config;
import jodie.kb.Role;
import jodie.kb.Term;
import jodie.kb.TermList;
import jodie.tableaux.AssertList;
import jodie.tableaux.Assertion;
import jodie.tableaux.Edge;
import jodie.tableaux.Node;
import jodie.tableaux.NodeList;

/**
 * @author eynard
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class StrategySH extends Strategy{

	// inherited protected attributes:
	// Tableaux tab;
	// boolean DEBUG
	
	public StrategySH() {
		super();
	}

	public void applyRules(){
		if (tab == null) {
			System.out.println ("Trying to run strategy without a tableaux. Use setTableaux!");
			System.exit(0);
		}
		applySATRule(tab.getRootNode());
		if (!tab.getRootNode().isSatisfiable()){
			tab.setClash();
		}
	}

	public boolean trigRules(Node n){
		boolean trigger = false;
		AssertList asserts = n.getAsserts();
		
		for (int i=0; i<asserts.size(); i++){
			Term t = asserts.getAssert(i).getTerm();
			if (	t.isComplex() && (
					t.getName().equalsIgnoreCase(Term.AND) 
					)){
				trigger = true;
				break;
			}
		}
		return trigger;
	}
	
	public void applySomeRule(Node n){
		Config.core.timers.startTimer("[TAB][SOME]");

		if (DEBUG) tab.log.out ("[SOME] Applying SOME rule on node " + n.getName());

		ListIterator li = n.getAsserts().listIterator();
		while (li.hasNext()){
			// for each assertion
			Assertion ass = (Assertion)li.next();
			Term t = ass.getTerm();
			// if the assertion has the form some(role,concept)
			if (t.isComplex() && t.getName().equalsIgnoreCase(Term.SOME)){

				if (DEBUG) tab.log.out ("[SOME] found " + t);
				// remove it
				// li.remove();
				// first term should be a simple role
				Role r = n.getTableaux().getKB().getTBox().getRole(t.getChild(0).getName());
				// second term should be a generic concept
				Term c = t.getChild(1);

				AssertList lx = new AssertList();
				// add concept to the list
				lx.add(ass.spawn(c));
				
				// - add all the D | all(S,D) and R implies S
				// - add all the all(S,D) of this node, 
				//   where S is transitive and R implies S
				
				AssertList asserts = n.getAsserts();
				for (int i=0; i<asserts.size(); i++){
					Term u = asserts.getAssert(i).getTerm();
					// check all the ALL asserted
					if (u.isComplex() && u.getName().equalsIgnoreCase(Term.ALL)){
						// first term should be a simple role
						Role s = n.getTableaux().getKB().getTBox().getRole(u.getChild(0).getName());
						// second term should be a generic concept
						Term d = u.getChild(1);

						// if R implies S
						if (r.implies(s)){
							// if S is transitive add ALL
							if (s.isTransitive()) lx.add(ass.spawn(u));
							// add D
							lx.add(ass.spawn(d));
						}
					}
				}

				// get ancestors of this node
				NodeList ancestors = n.getAncestors();
				// System.out.println ("*** Checking assertlist on these ancestors: "+ ancestors);
				for (int i=0; i<ancestors.size(); i++){
					Node a = ancestors.getNode(i);
					// if one of the ancestors contains these asserts
					if (a.getAsserts().contains(lx)){
						//System.out.println("Ancestor "+a.getName()+ " of "+n.getName()+" already contains asserts.");
						// empty asserts
						lx.clear();
						break;
					}
				}
				
				// now create an r-successor y with L(y)=lx
				String nodeName = n.getTableaux().getNewAnon();
				if (DEBUG) tab.log.out ("[SOME] creating new node for " + t + "(name: "+ nodeName +")");
				// create a new node with an anonymous name
				Node child = new Node(nodeName,n.getTableaux());
				// make it the child of the current node,
				// through an edge with role's name
				n.addChild(child,r.getName());
				// add the concept to the new node as an assertion
				child.addAssertions(lx);
			}
		}
		Config.core.timers.stopTimer("[TAB][SOME]");
	}

	public void applyOrRule(Node n){
		Config.core.timers.startTimer("[TAB][OR]");
		if (DEBUG) tab.log.out ("[OR] Applying OR rule on node " + n.getName());

		ListIterator li = n.getAsserts().listIterator();
		while (li.hasNext()){
			// for each assertion
			Assertion ass = (Assertion)li.next();
			Term t = ass.getTerm();
			// if the assertion has the form OR(a,b,c)
			if (t.isComplex() && t.getName().equalsIgnoreCase(Term.OR)){
				// remove it
				// li.remove();

				TermList children = t.getChildren();

				// first check that both of the children aren't asserted yet
				boolean asserted = false;
				for (int i=0; i<children.size(); i++){
					if (n.contains(children.getTerm(i))){
						asserted = true;
						break;
					}
				}
				if (asserted){
					// if (DEBUG) tab.log.out ("[OR] One child is asserted yet, I will skip this whole OR");
					continue;
				} 
				
				// foreach concept...
				for (int i=0; i<children.size(); i++){
					Term orTerm = children.getTerm(i);
					// create a new U-successor y with L(y)=L(x)+(C)
					String nodeName = n.getTableaux().getNewAnon();
					// if (DEBUG) tab.log.out ("[OR] creating new node for " + t + "(name: "+ nodeName +")");
					// create a new node with an anonymous name
					Node succ = new Node(nodeName,n.getTableaux());
					// make it the child of the current node,
					// through an edge with role's name
					n.addChild(succ,Edge.noLabel);
					// add the concept to the new node as an assertion
					succ.addAssertions(n.getAsserts());
					succ.addAssertion(ass.spawn(orTerm));
				}
			}
		}
		Config.core.timers.stopTimer("[TAB][OR]");
	}

	public boolean applySATRule(Node n){

		if (n.isSatisfiable()) return true; // this should never happen

		// apply rules
		applyUnfoldRule(n);
		
		while (trigRules(n)){
		
			applyAndRule(n);

			applyBCP(n);

		}

		applyOrRule(n);

		boolean sat = false;
		
		// if the L(x) of this node is a pretableau...
		if (n.preTableaux()){

			// NOTE: SOME rule works on preTableaux, so ORs have to be expanded before
			applySomeRule(n);

			boolean hasSome = false;
			AssertList asserts = n.getAsserts();
			for (int i=0; i<asserts.size(); i++){
				Term t = asserts.getAssert(i).getTerm();
				if (t.isComplex() && t.getName().equalsIgnoreCase(Term.SOME)){
					hasSome = true;
					break;
				}
			}
			// ... and contains no SOME, mark it as SAT
			if (!hasSome){
				sat = true;
			}

			// otherwise if it has successors, all of which are SAT...
			boolean sucSAT = true;
			NodeList successors = n.getChildren();
			for (int i=0; i<successors.size(); i++){
				Node s = successors.getNode(i);
				if (!applySATRule(s)){
					sucSAT = false;
					break;
				}
			}
			// ... mark it as SAT
			if (sucSAT){
				sat = true;
			}
		}else{
			// the L(x) of this node is not a pretableau,
			// but some U-successor of x is marked SAT
			boolean uSAT = false;
			NodeList uSucc = n.getUSuccessors(); 
			
			// in this case, we should ignore this node from U-successors
			// (to avoid infinite loops), so it starts from 1
			for (int i=1; i<uSucc.size(); i++){
				try{
					Node s = uSucc.getNode(i);
					if (applySATRule(s)){
						uSAT = true;
						break;
					}
				}catch (Exception e){
					e.printStackTrace();
				}
			}
			// ... mark it as SAT
			if (uSAT){
				sat = true;
			}
		}

		if (sat){
			n.setSatisfiable();
		}else{
			//node is not satisfiable, prune its children
			//n.getChildren().clear();
			//System.gc();
			// NOTE: THE LINES ABOVE DO NOT HELP MUCH!
			// Find if the node is referenced elsewhere too
		}
		
		return sat;
	}
}
                                                                                                                                                                                                                                                                                                                                                 