/*
 * Created on Mar 22, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jodie.strategies;

import java.util.LinkedList;
import java.util.ListIterator;

import jodie.core.Config;
import jodie.kb.Role;
import jodie.kb.Term;
import jodie.tableaux.AssertList;
import jodie.tableaux.Assertion;
import jodie.tableaux.Edge;
import jodie.tableaux.Node;
import jodie.tableaux.NodeList;

/**
 * @author eynard
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class StrategySHf extends StrategySH{

	public StrategySHf() {
		super();
	}
	
	// some rule has to be modified for SHf
	public void applySomeRule(Node n){
		Config.core.timers.startTimer("[TAB][SOME]");

		if (DEBUG) tab.log.out ("[SOME] Applying SOME rule on node " + n.getName());

		ListIterator li = n.getAsserts().listIterator();
		while (li.hasNext()){
			// for each assertion
			Assertion ass = (Assertion)li.next();
			Term t = ass.getTerm();
			// if the assertion has the form some(role,concept)
			if (t.isComplex() && t.getName().equalsIgnoreCase(Term.SOME)){

				if (DEBUG) tab.log.out ("[SOME] found " + t);
				// first term should be a simple role
				Role r = n.getTableaux().getKB().getTBox().getRole(t.getChild(0).getName());
				// second term should be a generic concept
				Term c = t.getChild(1);

				if (!r.isFunctional()){
					AssertList lx = new AssertList();
					// add concept to the list
					lx.add(ass.spawn(c));
					
					// - add all the D | all(S,D) and R implies S
					// - add all the all(S,D) of this node, 
					//   where S is transitive and R implies S
					
					AssertList asserts = n.getAsserts();
					for (int i=0; i<asserts.size(); i++){
						Term u = asserts.getAssert(i).getTerm();
						// check all the ALL asserted
						if (u.isComplex() && u.getName().equalsIgnoreCase(Term.ALL)){
							// first term should be a simple role
							Role s = n.getTableaux().getKB().getTBox().getRole(u.getChild(0).getName());
							// second term should be a generic concept
							Term d = u.getChild(1);

							// if R implies S
							if (r.implies(s)){
								// if S is transitive add ALL
								if (s.isTransitive()) lx.add(ass.spawn(u));
								// add D
								lx.add(ass.spawn(d));
							}
						}
					}

					// get ancestors of this node
					NodeList ancestors = n.getAncestors();
					// System.out.println ("*** Checking assertlist on these ancestors: "+ ancestors);
					for (int i=0; i<ancestors.size(); i++){
						Node a = ancestors.getNode(i);
						// if one of the ancestors contains these asserts
						if (a.getAsserts().contains(lx)){
							//System.out.println("Ancestor "+a.getName()+ " of "+n.getName()+" already contains asserts.");
							// empty asserts
							lx.clear();
							break;
						}
					}
					
					// now create an r-successor y with L(y)=lx
					String nodeName = n.getTableaux().getNewAnon();
					if (DEBUG) tab.log.out ("[SOME] creating new node for " + t + "(name: "+ nodeName +")");
					// create a new node with an anonymous name
					Node child = new Node(nodeName,n.getTableaux());
					// make it the child of the current node,
					// through an edge with role's name
					n.addChild(child,r.getName());
					// add the concept to the new node as an assertion
					child.addAssertions(lx);
				}else{
					// role is functional.
					if (DEBUG) tab.log.out ("[SOME] Role "+r.getName()+" is functional.");
					// Check if A-successors contain role R between their labels
					boolean donothing = false;
					for (int i=0; i<n.getEdges().size(); i++){
						Edge e = (Edge)n.getEdges().get(i);
						if (e.getNameLabels().contains(r.getName())){
							donothing = true;
							break;
						}
					}
					// if there's an edge containing r between its labels, do nothing
					if (donothing) break; 
					
					// else create a linkedlist which will contain all the attributes
					// constrained by r in L(x)
					LinkedList A = new LinkedList();
					
					// add all the superattributes of r (note: r is a superrole of r too)
					LinkedList aSuperRoles = r.getSuperRoles();
					for (int i=0; i<aSuperRoles.size(); i++){
						String s = (String)aSuperRoles.get(i);
						if (n.getTableaux().getKB().getTBox().getRole(s).isFunctional())
							A.add(s);
					}

					// add all the roles s such that SOME(s,c) and s is a subrole
					// of one of the roles listed in A
					AssertList asserts = n.getAsserts();
					for (int i=0; i<asserts.size(); i++){
						Term u = asserts.getAssert(i).getTerm();
						// check all the SOME asserted
						if (u.isComplex() && u.getName().equalsIgnoreCase(Term.SOME)){
							// first term should be a simple role
							Role s = n.getTableaux().getKB().getTBox().getRole(u.getChild(0).getName());
							LinkedList sSuperRoles = s.getSuperRoles();
							for (int j=0; j<sSuperRoles.size();j++){
								String sSuperRoleName = (String)sSuperRoles.get(j);
								if (A.contains(sSuperRoleName) && !A.contains(s.getName())){
									A.add(s.getName());
									break;
								}
							}
						}
					}

					if (DEBUG) tab.log.out ("[SOME] At the end, A is as follows: " +A);
					AssertList lax = new AssertList();
					// add concept to the list
					//lax.add(ass.spawn(c));

					for (int i=0; i<A.size(); i++){
						Role b = n.getTableaux().getKB().getTBox().getRole((String)A.get(i));
						//System.out.println ("*** Role: "+b.getName());
						// now, foreach b in A, add the following to lax:
						
						// D | some(B,D) in L(x)
						asserts = n.getAsserts();
						//System.out.println ("*** Asserts: "+asserts);
						for (int j=0; j<asserts.size(); j++){
							Term u = asserts.getAssert(j).getTerm();
							//System.out.println ("*** Term: " + u);
							// check all the SOME asserted
							if (u.isComplex() && u.getName().equalsIgnoreCase(Term.SOME)){
								//System.out.println ("*** Got SOME: " + u);
								// first term should be a simple role
								if (u.getChild(0).getName().equalsIgnoreCase(b.getName())){
									// second term should be a generic concept
									Term d = u.getChild(1);
									// add the concept 
									lax.add(ass.spawn(d));
								}
							}
						}
						
						// D | all(S,D) in L(x) and B implies S
						// all(S,D) | all(S,D) in L(x) and B implies S and S is transitive
						asserts = n.getAsserts();
						for (int j=0; j<asserts.size(); j++){
							Term u = asserts.getAssert(i).getTerm();
							// check all the ALL asserted
							if (u.isComplex() && u.getName().equalsIgnoreCase(Term.ALL)){
								// first term should be a simple role
								Role s = n.getTableaux().getKB().getTBox().getRole(u.getChild(0).getName());
								// second term should be a generic concept
								Term d = u.getChild(1);

								// if R implies S
								if (b.implies(s)){
									// if S is transitive add ALL
									if (s.isTransitive()) lax.add(ass.spawn(u));
									// add D
									lax.add(ass.spawn(d));
								}
							}
						}
					}

					// get ancestors of this node
					NodeList ancestors = n.getAncestors();
					// System.out.println ("*** Checking assertlist on these ancestors: "+ ancestors);
					for (int i=0; i<ancestors.size(); i++){
						Node a = ancestors.getNode(i);
						// if one of the ancestors contains these asserts
						if (a.getAsserts().contains(lax)){
							//System.out.println("Ancestor "+a.getName()+ " of "+n.getName()+" already contains these asserts: "+lax);
							// empty asserts
							lax.clear();
							break;
						}
					}
					
					// now create an A-successor y with L(y)=lax
					String nodeName = n.getTableaux().getNewAnon();
					if (DEBUG) tab.log.out ("[SOME] creating new A-successor node for " + t + "(name: "+ nodeName +")");
					// create a new node with an anonymous name
					Node child = new Node(nodeName,n.getTableaux());
					// make it the child of the current node,
					// through an edge with role's name
					n.addChild(child,r.getName());
					// get the connecting edge
					Edge e = child.getParentEdge();
					// add the labels list to the edge
					e.getNameLabels().addAll(A);
					// add the concept to the new node as an assertion
					child.addAssertions(lax);
				}
			}
		}
		Config.core.timers.stopTimer("[TAB][SOME]");
	}
}
                                                                                                                                                                                                                                                                                                                                                 