/*
 * Created on Mar 22, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jodie.strategies;

import java.util.LinkedList;
import java.util.ListIterator;

import jodie.core.Config;
import jodie.kb.Term;
import jodie.kb.TermList;
import jodie.tableaux.AssertList;
import jodie.tableaux.Assertion;
import jodie.tableaux.Edge;
import jodie.tableaux.Label;
import jodie.tableaux.Node;
import jodie.tableaux.NodeList;

/**
 * @author eynard
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class StrategySI extends Strategy{

	// inherited protected attributes:
	// Tableaux tab;
	// boolean DEBUG
	
	// inherited protected methods:
	// applyAllRule 
	
	public StrategySI() {
	}

	public void applyRules(){
		if (tab == null) {
			System.out.println ("Trying to run strategy without a tableaux. Use setTableaux!");
			System.exit(0);
		}

		while(true){
			Node n = new Node("fuffa",tab);
			while (tab.getQueue().size()>0 && !n.clashes()){
				// get the first element from the queue
				// we will pop it away only if there are no more operations to accomplish
				n = tab.getQueue().removeFirst();

				// first, check the trivial case (node clashes before any rule)
				if (n.clashes()){
					if (DEBUG) tab.log.out ("Found a clash immediately in node " + n.getName());
					continue;
				}
				
				// apply rules
				applyUnfoldRule(n);
				if (n.clashes()){
					if (DEBUG) tab.log.out ("Found a clash after unfolding " + n.getName());
					continue;
				}
				// if (DEBUG) tab.log.out ("Node after UNFOLD is " + n);

				applyAndRule(n);
				if (n.clashes()){
					if (DEBUG) tab.log.out ("Found a clash after AND in node " + n.getName());
					continue;
				}
				// if (DEBUG) tab.log.out ("Node after AND is " + n);

				applyBCP(n);
				if (n.clashes()){
					if (DEBUG) tab.log.out ("Found a clash after BCP in node " + n.getName());
					continue;
				}
				// if (DEBUG) tab.log.out ("Node after BCP is " + n);

				applySomeRule(n);
				
				applyAllRule(n);

				applyOrRule(n);
				if (n.clashes()){
					if (DEBUG) tab.log.out ("Found a clash after OR in node " + n.getName());
					continue;
				}
				// if (trigRules(n)) continue;
				// tab.getQueue().removeFirst();
			}
			if(n.clashes()){
				// fai il rollback: get the topmost label
				
				
				
			}else{
				// satisfiable! tableaux doesn't clash, queue is empty
				break;
			}
		}
	}

	protected void applyBCP(Node n){
		Config.core.timers.startTimer("[TAB][BCP]");

		if (DEBUG) tab.log.out("[BCP] Executing applyBCP");
		
		AssertList ass = n.getAsserts();

		ListIterator lj = ass.listIterator();
		// foreach assert...
		while (lj.hasNext()){

			// Get assertion
			Assertion a = (Assertion)lj.next();
			Term t = a.getTerm();
			
			if (t.isComplex() && t.getName().equalsIgnoreCase(Term.OR)){
				boolean modified = false;
				//tab.log.out("[BCP] Found an OR in node "+n.getName());
				//tab.log.out("[BCP] Full form is: " + t);

				ListIterator li = t.getChildren().listIterator();
				// foreach concept...
				while (li.hasNext()){
					Term child = (Term)li.next();

					//tab.log.out("[BCP] Checking if child "+child+" clashes");

					// the cases are:
					// simple term or NOT(term): just check for its negation
					if (child.isSimple() || child.getName().equalsIgnoreCase(Term.NOT)){
						//tab.log.out ("[BCP] Child " + child + " is simple");
						if (ass.contains(child.negate().simplify())){
							//tab.log.out("[BCP] Child " + child + " clashes: removing it");
							//tab.log.out("[BCP] => assertions are " + ass);
							//tab.log.out("[BCP] => they contain " + child.negate().simplify());
							li.remove();
							modified = true;
						}
					}

					// AND(a,b,c): just check if one of them clashes
					if (child.getName().equalsIgnoreCase(Term.AND)){
						boolean andClash = false;
						TermList andChildren = child.getChildren();
						for (int j=0; j<andChildren.size();j++){
							//tab.log.out ("[BCP] [AND] Checking with " + andChildren.getTerm(j));
							if (ass.contains(andChildren.getTerm(j).negate().simplify())){
								andClash = true;
								break;
							}
						}
						if (andClash){
							//tab.log.out ("[BCP] [AND] Yea, "+child+" clashes! I'm going to remove it");
							li.remove();
							modified = true;
						}
					}
				}
				
				// if, at the end of the process, the OR has no children, it means every
				// one of them was clashing... so the whole OR CLASHES! Set it to BOTTOM
				if (t.getChildren().size() == 0) {
					//tab.log.out ("[BCP] Assert has no more children: all of them clash, so the whole assert CLASHES");
					lj.set(a.spawn(Term.BOTTOM));
					modified = true;
				}

				// if, instead, the OR has one children, keep it and delete the OR
				if (t.getChildren().size() == 1){
					//tab.log.out ("[BCP] Assert has one child, I'm gonna simplify it");
					if (ass.contains(t.getChild(0))){
						// if the node contains the assert yet just delete it 
						//lj.remove();
						lj.set(a.spawn(Term.TOP));
						modified = true;
					}else{
						lj.set(a.spawn(t.getChild(0)));
						modified = true;
					}
				}
				//tab.log.out ("[BCP] Old term now is: " + t + "\n");
			}
		}
		Config.core.timers.stopTimer("[TAB][BCP]");
	}

	public boolean trigRules(Node n){
		boolean trigger = false;
		AssertList asserts = n.getAsserts();
		
		for (int i=0; i<asserts.size(); i++){
			
			Term t = asserts.getAssert(i).getTerm();
			if (	t.isComplex() && (
					t.getName().equalsIgnoreCase(Term.AND) ||
					t.getName().equalsIgnoreCase(Term.SOME) ||
					t.getName().equalsIgnoreCase(Term.ALL) ||
					t.getName().equalsIgnoreCase(Term.OR) 
					)){
				trigger = true;
				break;
			}
		}
		return trigger;
	}
	
	protected void applyAndRule(Node n){
		// NOTE: this method could make the current node clash!
		Config.core.timers.startTimer("[TAB][AND]");
		if (DEBUG) tab.log.out ("[AND] Applying AND rule on node " + n.getName());

		// if n is indirectly blocked do nothing
		if (n.isIndirectlyBlocked()) return;
		
		ListIterator li = n.getAsserts().listIterator();
		while (li.hasNext()){
			// for each assertion
			Assertion ass = (Assertion)li.next();
			Term t = ass.getTerm();
			// if the assertion has the form and(a,b,c)
			if (t.isComplex() && t.getName().equalsIgnoreCase(Term.AND)){
				// remove it
				li.remove();
				
				TermList children = t.getChildren();
				// and add a, b, c
				for (int i=0; i<children.size(); i++){
					Term child = children.getTerm(i);
					// add assertion only if it's not in the node yet
					// NOTE: the new assertions will have the same 
					// label of their father
					if (!n.contains(child))	li.add(ass.spawn(child));
				}
			}
		}
		Config.core.timers.stopTimer("[TAB][AND]");
	}

	public void applySomeRule(Node n){
		// NOTE: this method should not create immediate clashing nodes:
		// - first of all, it's always a new node (so no conflicts with ex. ones)
		// - then, the new term is pushed in the queue so if it clashes we'll 
		//   see that later

		Config.core.timers.startTimer("[TAB][SOME]");
		if (DEBUG) tab.log.out ("[SOME] Applying SOME rule on node " + n.getName());
		
		// if n is blocked do nothing
		if (n.isBlocked()) return;
		if (DEBUG) tab.log.out ("[SOME] node " + n.getName() + " is not blocked.");
		
		ListIterator li = n.getAsserts().listIterator();
		while (li.hasNext()){
			// for each assertion
			Assertion ass = (Assertion)li.next();
			Term t = ass.getTerm();
			// if the assertion has the form some(role,concept)
			if (t.isComplex() && t.getName().equalsIgnoreCase(Term.SOME)){
				if (DEBUG) tab.log.out ("[SOME] found " + t);

				// remove it
				li.remove();
				// first term should be a simple role
				Term role = t.getChild(0);
				// second term should be a generic concept
				Term concept = t.getChild(1);

				// NOTE: first check if an R-neighbour of n...
				NodeList nl = getRNeighbours(n, role.getName()); 

				//       ... asserting Concept exists yet
				boolean found = false;
				for (int i=0;i<nl.size();i++){
					Node child = (Node)nl.get(i);
					if (child.contains(concept)){
						found = true;
						break;
					}
				}

				if (!found){
					String nodeName = n.getTableaux().getNewAnon();
					if (DEBUG) tab.log.out ("[SOME] creating new node for " + t + "(name: "+ nodeName +")");
					// if not, create a new node with an anonymous name
					Node child = new Node(nodeName,n.getTableaux());
					// make it the child of the current node,
					// through an edge with role's name
					n.addChild(child,role.getName());
					// add the concept to the new node as an assertion
					child.addAssertion(ass.spawn(concept));
					// add the new node to the queue
					n.getTableaux().enqueueNode(child);
				}
			}
		}
		Config.core.timers.stopTimer("[TAB][SOME]");
	}

	public void applyAllRule(Node n){
		// NOTE: this method should not create immediate clashing nodes:
		// - it only add assertions to children nodes, so THEY might clash, not
		//   the current node

		Config.core.timers.startTimer("[TAB][ALL]");
		if (DEBUG) tab.log.out ("[ALL] Applying ALL rule on node " + n.getName());

		// if n is indirectly blocked do nothing
		if (n.isIndirectlyBlocked()) return;

		ListIterator li = n.getAsserts().listIterator();
		while (li.hasNext()){
			// for each assertion
			Assertion ass = (Assertion)li.next();
			Term t = ass.getTerm();
			// if the assertion has the form all(role,concept)
			if (t.isComplex() && t.getName().equalsIgnoreCase(Term.ALL)){
				// remove it
				li.remove();
				
				// first term should be a simple role
				Term role = t.getChild(0);
				// second term should be a generic concept
				Term concept = t.getChild(1);
				
				// for all the nodes whose edge has role's name
				LinkedList neighbours = getRNeighbours(n, role.getName());
				for (int i=0;i<neighbours.size();i++){
					// add the concept to the node as an assertion
					Node neighbour = (Node)neighbours.get(i);
					if (!neighbour.contains(concept)){
						// do that only if concept is not asserted yet
						neighbour.addAssertion(ass.spawn(concept));
						// NOTE: since the method has added a new assertion to some 
						//       nodes, we will have to enqueue it for a later check
						n.getTableaux().enqueueNode(neighbour);
					}
					// if the role is transitive
					if (this.tab.getKB().getTBox().getRole(role.getName()).isTransitive()){
						// add the ALL assertion to the R-Neighbour too
						if (!neighbour.contains(t)){
							// do that only if concept is not asserted yet
							neighbour.addAssertion(ass.spawn(t));
							// NOTE: since the method has added a new assertion to some 
							//       nodes, we will have to enqueue it for a later check
							n.getTableaux().enqueueNode(neighbour);
						}
					}
				}
			}
		}
		Config.core.timers.stopTimer("[TAB][ALL]");
	}

	public void applyOrRule(Node n){
		Config.core.timers.startTimer("[TAB][OR]");
		if (DEBUG) tab.log.out ("[OR] Applying OR rule on node " + n.getName());

		ListIterator li = n.getAsserts().listIterator();
		while (li.hasNext()){
			// for each assertion
			Assertion ass = (Assertion)li.next();
			Term t = ass.getTerm();
			// if the assertion has the form OR(a,b,c)
			if (t.isComplex() && t.getName().equalsIgnoreCase(Term.OR)){
				if (DEBUG) tab.log.out ("[OR] Working on assertion " + t);
				// remove it
				li.remove();

				// create a new label and save it
				Label l = new Label(n,t);
				tab.putLabel(l);
				
				// get the first term
				Term child = l.popTerm();
				if (DEBUG) tab.log.out ("[OR] Adding assertion " + child + " to node");
				
				// if it's not asserted yet (uhhmm... shouldn't happen after BCP!)
				if (child != null && !n.contains(child)){
					Assertion childAss = ass.spawn(child);
					childAss.setLabel(l.getHash());
					li.add(childAss);
				}else{
					if (DEBUG) tab.log.out ("[OR] Child is asserted yet, I won't add it.");
				}
					
				if (DEBUG) tab.log.out ("[OR] Enqueueing node "+n.getName());
				// attenzione: il nodo esiste ancora in coda, quindi non viene
				// aggiunto. In compenso, all'uscita da questa funzione si torna
				// ad applyrules dove viene levato!!!
				tab.enqueueNode(n);
			}
		}
		Config.core.timers.stopTimer("[TAB][OR]");
	}

	public NodeList getRNeighbours(Node n, String edgeName){
		// a node y is called an R-Neighbour of x if either
		// y is a successor of x and L(<x,y>)=R or
		// y is a predecessor of x and L(<y,x>)=inv(R)
		NodeList nodes = new NodeList();
		
		// get the name of the inverse role (if it exists)
		String inverseEdgeName = 
			tab.getKB().getTBox().getRole(edgeName).getInverse().getName();

		// get neighbours
		// getEdges returns all the edges starting from n
		for (int i=0; i<n.getEdges().size();i++){
			Edge e = (Edge)n.getEdges().get(i);
			// either you get the edgeName-successor...
			if (e.getName().equalsIgnoreCase(edgeName)){
				nodes.add(e.getBottom());
			}
		}

		Edge e = n.getParentEdge();
		if (e != null && inverseEdgeName != null){
			// ... or you get the inverseEdgeName-predecessor 
			if (e.getName().equalsIgnoreCase(inverseEdgeName)){
				nodes.add(e.getTop());
			}
		}
			
		return nodes;
	}

}
