/*
 * Created on 15-feb-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jodie.tableaux;

import java.util.LinkedList;

import jodie.kb.TBox;
import jodie.kb.Term;


/**
 * @author mala
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class AssertList extends LinkedList{

	public AssertList(){
		super();
	}

	public boolean equals(AssertList list){
		if (this.size()!=list.size()) return false;

		// for an assertlist, the order of the asserts is not important!
		// assertlist a equals assertlist b if all they have the same size
		// and all the terms of a are contained in b (there can't be dupes)
		boolean eq = true;
		for (int i=0;i<this.size();i++){
			if (!list.contains(this.getAssert(i).getTerm())){
				eq=false;
				break;
			}
		}
		return eq;
	}
	
	public boolean contains(Term t){
		return this.contains(t,0);
	}
	
	public boolean contains(Term t, int idx){
		boolean cont = false;
		if (idx>=this.size()) {
			return false;
		}
		
		for (int i=idx;i<this.size();i++){
			Term child = this.getAssert(i).getTerm();
			if (child.equals(t)){
				cont=true;
				break;
			}
		}
		return cont;
	}

	// In fact, we check if all the terms contained in the
	// passed assertions list are also contained in this
	// assertion list
	public boolean contains (AssertList tl){
		boolean cont = true;
		for (int i=0; i<tl.size(); i++){
			if (!this.contains(tl.getAssert(i).getTerm())){
				cont = false;
				break;
			}
		}
		return cont;
	}

	public Assertion getAssert(int i){
		return (Assertion)super.get(i);
	}

	public AssertList simplify(){
		for (int i=0;i<this.size();i++){
			this.getAssert(i).simplify();
		}
		return this;
	}	
	
	public AssertList negate(){
		for (int i=0;i<this.size();i++){
			this.getAssert(i).negate();
		}
		return this;
	}
	
	public AssertList normalize(){
		for (int i=0;i<this.size();i++){
			this.getAssert(i).normalize();
		}
		return this;
	}

	public AssertList lazyUnfold(TBox tbox){
		for (int i=0;i<this.size();i++){
			this.getAssert(i).lazyUnfold(tbox);
		}
		return this;
	}

	public AssertList nnf(){
		for (int i=0;i<this.size();i++){
			this.getAssert(i).nnf();
		}
		return this;
	}

    public Object clone(){
		AssertList tl = (AssertList)super.clone();
		for (int i=0; i<tl.size();i++){
			tl.set(i,((Assertion)tl.get(i)).clone());
		}
		return tl;
	}
}
