/*
 * Created on 21-mag-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jodie.tableaux;

import jodie.kb.TBox;
import jodie.kb.Term;

/**
 * @author da
 *
 * Assertion is a container for term.
 * It manages labels and everything which is not strictly
 * related to the term object.
 */
public class Assertion implements Cloneable{

	private Term t;
	
/*	private boolean isSimple	= false;
	private boolean isNormal	= false;
	private boolean isUnfold	= false;
	private boolean isNnf		= false;
	private boolean expanded	= false; // you can use this to see if a rule has been applied yet
*/
	private String	label 		= "";
	
	public Assertion(Term t) {
		this.t = t;
	}

	public void setLabel(String s){
		this.label = s;
	}

	public String getLabel(){
		return this.label;
	}

	public Assertion spawn(Term t){
		Assertion a = new Assertion(t);
/*		a.isSimple = isSimple;
		a.isNormal = isNormal;
		a.isUnfold = isUnfold;
		a.isNnf    = isNnf; */
		a.label = this.label;
		return a;
	}
	
	public Term getTerm(){
		return t;
	}
	
	// simplify
	public Assertion simplify(){
	//	if (!isSimple){
			t = t.simplify();
	//		isSimple = true;
	//	}
		return this;
	}
	
	// negate
	public Assertion negate(){
		t = t.negate();
		return this;
	}
	
	// normalize
	public Assertion normalize(){
	//	if (!isNormal){
			t = t.normalize();
	//		isNormal = true;
	//	}
		return this;
	}
	
	
	// lazy unfold
	public Assertion lazyUnfold (TBox tbox){
	//	if (!isUnfold){
			t = t.lazyUnfold(tbox);
	//		isUnfold = true;
	//		isSimple = false;
	//	}
		return this;
	}
	
	// nnf
	public Assertion nnf (){
	//	if (!isNnf){
			t = t.nnf();
	//		isNnf = true;
	//	}
		return this;
	}
	
	// clone
	public Object clone(){
		Assertion a = null;
		try {
			a = (Assertion)super.clone(); // shallow clone
			// clone attributes
			// ...
			
			// clone contained term
			a.t = (Term)t.clone();
		} catch (CloneNotSupportedException e) {
			e.printStackTrace();
		}
		return a;
	}

	public String toString(){
		String s = "";
		/*
		s += isSimple? "S" : "s";
		s += isNormal? "N" : "n";
		s += isUnfold? "U" : "u";
		s += isNnf   ? "F" : "f";
		*/
		s += "["+label+"] ";
		s += t;
		return s;
	}
}
